<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    selectedTab: {
      type: Number,
      required: true,
      default: 0,
    },
  },
  data() {
    return {
      open: false,
    };
  },
  methods: {
    toggleOpen() {
      this.open = !this.open;
    },
    changeTab(tabIndex) {
      this.$emit('tab-change', tabIndex);
      this.toggleOpen();
    },
  },
});
</script>

<template>
  <div class="tabs-dropdown__wrapper">
    <div class="tabs-dropdown">
      <div class="control" @click="toggleOpen">
        <div class="label">
          <SlpIcon
            class="icon"
            :name="data.tabs[selectedTab].header.icon"
            variant="marketing"
            size="md"
          />
          <SlpTypography variant="body2">
            {{ data.tabs[selectedTab].header.text }}</SlpTypography
          >
        </div>
        <SlpIcon
          :name="open ? 'chevron-up' : 'chevron-down'"
          variant="product"
          size="md"
        />
      </div>
      <div v-if="open" class="options">
        <div
          v-for="(tab, tabIndex) in data.tabs"
          :key="tab.header.text"
          class="option"
          :class="{ selected: selectedTab === tabIndex }"
          @click="changeTab(tabIndex)"
        >
          <SlpIcon
            class="icon"
            :name="tab.header.icon"
            variant="marketing"
            size="md"
          />
          <SlpTypography variant="body2"> {{ tab.header.text }}</SlpTypography>
        </div>
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.tabs-dropdown {
  &__wrapper {
    padding: 24px 8px;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }
  @media (min-width: $breakpoint-md) {
    display: none;
  }
  .control {
    display: flex;
    justify-content: space-between;
    align-items: center;
    width: 100%;
    padding: 4px 8px;
  }
  .options {
    padding: 0 $spacing-8;
  }
  .icon {
    margin-right: $spacing-8;
  }
  .option,
  .label {
    display: flex;
    align-items: center;
    text-align: left;
  }
  .option {
    margin: $spacing-16 0;
  }
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  padding: 4px 1px;
  border: 1px solid #74717a;
  border-radius: 4px;
}
</style>
